#ifndef ClassCoder_h
#define ClassCoder_h
#include "Arduino.h"
#include <Time.h>

// Адрес NRF24L01 для сервера
const uint16_t nrf24_server_node = 0;
const uint8_t  nrf24_channel     = 90;

// Адреса 1-10 сенсоры температуры

// Тип пакета RF24NetworkHeader.type
#define TYPE_PING        0x01  //Пакет с PING
#define TYPE_METEO1      0x11  //Метеосенсор 1-го типа
#define TYPE_INFORMER1   0x13  //Погода из интернета
#define TYPE_TIME1       0x20  //Время


struct TSMeteoSensor {
   unsigned long Uptime; //Время жизни сенсора
   unsigned int  Count;  //Счетчик пакетов
   float         V;      //Напряжение питания
   float         T;      //Температура
   float         P;      //Давление
   float         H;      //На всякий случай
};

struct TSInfoPacket1 {
   union {
       float     T;      //Температура
       time_t Time;      //ремя
   };
   union {
      float P;              //Давление
      unsigned long wind;   // Направление и скорость ветра
   };
   union {
      float H;              //Влажность
      unsigned long prec;   //Осадки и облачность
   };
};

static byte client_meteo_nodes[] = { 0x2, 0x3, 0x4, 0 };

#endif﻿
