#ifndef MatrixRGB_h
#define MatrixRGB_h
#include "Arduino.h"


/**
* Класс для отображения на дисплее
*/

class MatrixRGB {
  private:
// Номер цифровых выходов на дисплей  
     uint8_t PinCLK, PinEN, PinA0, PinA1, PinA2, PinR, PinG, PinB;
// Видеопамять
     byte ScreenBuffer[16][32];

     void SetColorRGB(boolean red1,boolean green1, boolean blue1);
     void SetColor( byte color );
     void SetRow3(boolean a0, boolean a1, boolean a2);
     void SetRow(int row);
     void SetClock();
  
  public:
     void SetPixel(int x, int y, byte c);

     MatrixRGB( uint8_t clk, uint8_t en, uint8_t a0, uint8_t a1, uint8_t a2, uint8_t r, uint8_t g, uint8_t b);
     void FillColor(byte color);
     void FillColor(byte color,uint8_t x1,uint8_t y1,uint8_t x2, uint8_t y2);
     void RefreshScreen(unsigned int brightness);

     void PrintChar6h(int x, int y, byte digit, byte color);
     void PrintChar8h(int x, int y, byte digit, byte color);
     void PrintIcon5x5(int x, int y,byte n, byte color);
     void PrintIcon7x7(int x, int y,byte n, byte color);
     void PrintIcon9x9(int x, int y,byte n, byte color);
 
     void begin();

};


#endif
