
#include <RF24Network.h>
#include <RF24.h>
#include <SPI.h>
#include <Time.h>

//#include <RCSwitch.h> //   http://code.google.com/p/rc-switch/
//#include <Wire.h>

//#define DEBUG 1
const uint16_t nrf24_node       = 0x02;

// Библиотека для работы с часами РВ
//#include <DS1307.h>

#include "ClassCoder.h"
#include "ClassAVG.h"
#include "MatrixRGB.h"


AVG t_avg = AVG(10);
//AVG h_avg = AVG(10);
AVG p_avg = AVG(10);


float t = 0;
float p = 0;
float h = 0;
uint8_t hr = 0,mn = 0;
unsigned long ms_rx = 0;
// Информация по информеру
unsigned long ms_informer = 0;
int t_informer = -99;
unsigned long  w_informer = 0;
unsigned long  p_informer = 0;

boolean is_time_mode = true;

// Проект погодной станции/часов V1.0
// Copyright (C) 2013 Шихарбеев А.В


/**********************************************************
* Работа с матричным дисплеем 8x16
**********************************************************
Распиновки разъема дисплея
0	G1	GRN   зеленый цвет, последовательность 0-63
1	CKL	GRN   тактовый сигнал
2	STR	GRN   не используется
3	R1	GRN   красный цвет, последовательность 0-63
4	R2	GRN   не используется
5	C	GRN   0-й бит адреса строки
6	B	GRN   1-й бит адреса строки
7	A	GRN   2-й бит адреса строки
8	EN	GRN   запись 64-х битов столбцов по каждому цвету
9	G2	GRN   синий цвет, последовательность 0-63 бит
*/

// 8 выходов управления дисплеем
#define MATRIX_CLK  3 
#define MATRIX_EN   8
#define MATRIX_A0   5
#define MATRIX_A1   6
#define MATRIX_A2   7
#define MATRIX_R    4
#define MATRIX_G    2
#define MATRIX_B    14

#define SIGN_NONE  18
#define SIGN_UP    14
#define SIGN_DOWN  13
#define SIGN_QUEST 15

//Глобальные переменные
RF24 radio(9,10);
RF24Network network(radio);
MatrixRGB myDisplay = MatrixRGB(MATRIX_CLK,MATRIX_EN,MATRIX_A0,MATRIX_A1,MATRIX_A2,MATRIX_R,MATRIX_G,MATRIX_B);


void setup() {
#ifdef DEBUG
  Serial.begin(9600);
  Serial.println("OK");
#endif

   SPI.begin();
   radio.begin();
   network.begin(nrf24_channel, nrf24_node);

   myDisplay.begin();

 
  
   myDisplay.FillColor(0);
   t_informer = 10;
} 

     
unsigned long ms1 = 0;
unsigned long ms2 = 0;
boolean time_sign = true;
long int t_correct = 0;

long int cur_ms;
   unsigned long n = 0;
void loop() {
  cur_ms = millis();
 

  unsigned long t_cur = (cur_ms/1000)%86400;

  network.update();

  // Is there anything ready for us?
  while ( network.available() )
  {
    RF24NetworkHeader header;
    struct TSInfoPacket1 sensor;
    network.read(header,&sensor,sizeof(sensor));
    if( header.type == TYPE_METEO1 ){
       t = round(sensor.T*10)/10.0;
       p = round(sensor.P*10)/10.0;
       h = sensor.H;
       t_avg.Set(t);
       p_avg.Set(p);
       ms_rx = cur_ms;
       if(is_time_mode)PrintTandP();
#ifdef DEBUG
          Serial.print("SENS: Temp=");
          Serial.print(t);
          Serial.print(" Press=");
          Serial.print(p);
          Serial.print(" Hum=");
          Serial.print(h);
          Serial.println("");
#endif
    }
    else if( header.type == TYPE_INFORMER1 ){
        ms_informer = cur_ms;
        t_informer  = (int)sensor.T;
        w_informer  = sensor.wind;
        p_informer  = sensor.prec;
#ifdef DEBUG
          Serial.print("Informer=");
          Serial.print(t_informer);
          Serial.print(" ");
          Serial.print(w_informer);
          Serial.print(" ");
          Serial.print(p_informer);
          Serial.println("");
#endif
        
    }
    else if( header.type == TYPE_TIME1 ){
       t_correct = (unsigned long)sensor.Time - t_cur;
       if(is_time_mode)PrintTime(hour(sensor.Time),minute(sensor.Time),7);
#ifdef DEBUG
          Serial.print("Time=");
          Serial.print(hour(sensor.Time));
          Serial.print(":");
          Serial.print(minute(sensor.Time));
          Serial.println("");
#endif
    }
    ms2 = cur_ms;
  }


  if( cur_ms - ms1 < 0 || cur_ms - ms1 > 500 ){
     if( is_time_mode ){ 
        PrintTimeSign(time_sign,7);
     }
     else {
        PrintRain(p_informer,time_sign);
     }
     time_sign = !time_sign;
     ms1 = cur_ms;
  }

  if( cur_ms - ms2 < 0 || cur_ms - ms2 > 6000 ){
// Корректность погодного информера
    if( ms_informer>0 && cur_ms - ms_informer < 1800000L ) is_time_mode = !is_time_mode;
     else is_time_mode = true;
     
     time_t tm1 = t_cur + t_correct;
     if( is_time_mode ){
        myDisplay.FillColor(0);
        PrintTime(hour(tm1),minute(tm1),7);
        PrintTandP();
     }
     else {
        PrintInformer(t_informer,w_informer,p_informer);
      }
     ms2 = cur_ms;
  }
  myDisplay.RefreshScreen(3);
} 


/**
* Печатаем время
*/
void PrintTime(uint8_t h, uint8_t m, byte color)
{
  //if( h != hr || m != mn ){
     uint8_t x2 = h%10;
     uint8_t x1 = (h/10)%10;
     myDisplay.PrintChar8h(6,0,x1,color);
     myDisplay.PrintChar8h(11,0,x2,color);
     x2 = m%10;
     x1 = (m/10)%10;
     myDisplay.PrintChar8h(18,0,x1,color);
     myDisplay.PrintChar8h(23,0,x2,color);
  //}
  //hr = h;
  //mn = m;
}

/**
* Печатаем двоеточие у времени
*/
void PrintTimeSign(boolean flag, byte color)
{
  if( flag ){
     myDisplay.SetPixel(16,2,color);
     myDisplay.SetPixel(16,5,color);
  }
  else { 
     myDisplay.SetPixel(16,2,0);
     myDisplay.SetPixel(16,5,0);
  }
}


/**
* Печатаем температуру
*/
void PrintT(float t1, uint8_t sign, byte color)
{
  boolean plus = true;
  uint16_t ti;
  if( t1 >= 0 )ti = t1*10;
  else {
    ti = t1*-10;
    plus = false;
  }
  uint8_t x3 = ti%10;
  uint8_t x2 = (ti/10)%10;
  uint8_t x1 = (ti/100)%10;
  uint8_t off = 0;
  if( plus )myDisplay.PrintChar6h(off,10,11,color);
  else myDisplay.PrintChar6h(off,10,10,color);
  off+=4;
  if( x1 > 0 ){
     myDisplay.PrintChar6h(off,10,x1,color);
     off+=4;
  }
  myDisplay.PrintChar6h(off,10,x2,color);
  off+=4;
  myDisplay.PrintChar6h(off-1,10,16,0);
  myDisplay.SetPixel(off,15,color);
  off+=2;
  myDisplay.PrintChar6h(off,10,x3,color);
  myDisplay.PrintChar6h(0,3,sign,color);
}

/**
* Печатаем давление
*/
void PrintP(uint16_t p, uint8_t sign, byte color)
{
  uint8_t x3 = p%10;
  uint8_t x2 = (p/10)%10;
  uint8_t x1 = (p/100)%10;
  uint8_t off = 21;
  myDisplay.PrintChar6h(off,10,x1,color);
  off+=4;
  myDisplay.PrintChar6h(off,10,x2,color);
  off+=4;
  myDisplay.PrintChar6h(off,10,x3,color);
  myDisplay.PrintChar6h(29,3,sign,color);
}


/**
* Выводем температуру и давление
*/
void PrintTandP(){
#ifdef DEBUG
          Serial.print("VAL: Temp=");
          Serial.print(t);
          Serial.print(" P=");
          Serial.print(p);
          Serial.print(" AVG: Temp=");
          Serial.print(t_avg.Get());
          Serial.print(" P=");
          Serial.print(p_avg.Get());
          Serial.println("");
 #endif  


   byte flag_T = SIGN_NONE;
   byte flag_P = SIGN_NONE;
   if( ms_rx == 0 || ms_rx > cur_ms || (cur_ms-ms_rx)>300000  ){
      flag_T = SIGN_QUEST;
      flag_P = SIGN_QUEST;
   }
   else {
      int ret = p_avg.Compare(p);
      if( ret>0 )flag_P = SIGN_UP;
      else if( ret<0 )flag_P = SIGN_DOWN;
      else flag_P = SIGN_NONE;
      
      ret = t_avg.Compare(t);
      if( ret>0 )flag_T = SIGN_UP;
      else if( ret<0 )flag_T = SIGN_DOWN;
      else flag_T = SIGN_NONE;
    }
   PrintT(t,flag_T,6); 
   PrintP(p,flag_P,3); 
}


void PrintInformer(int t1,unsigned long wind, unsigned long prec){

   myDisplay.FillColor(0);
  
// Температуру
#ifdef DEBUG
          Serial.print("INF: Temp=");
          Serial.print(t1);
#endif  

  boolean plus = true;
  uint16_t ti;
  if( t1 >= 0 )ti = t1;
  else {
    ti = t1;
    plus = false;
  }
  uint8_t x2 = (ti)%10;
  uint8_t x1 = (ti/10)%10;
  uint8_t off = 0;
  if( plus )myDisplay.PrintChar6h(off,1,11,6);
  else myDisplay.PrintChar6h(off,1,10,6);
  off+=4;
  if( x1 > 0 ){
     myDisplay.PrintChar8h(off,0,x1,6);
     off+=5;
  }
  myDisplay.PrintChar8h(off,0,x2,6);
  off+=5;
  myDisplay.PrintChar6h(off,0,16,6);
  off+=2;
  myDisplay.PrintChar6h(off,2,17,6);
  
 // Парсим скорость и направдение ветра
   uint16_t sp = wind%100;
   byte dir = (wind/100)%10;
 
#ifdef DEBUG
          Serial.print(" DIR=");
          Serial.print(dir);
          Serial.print(" SPEED=");
          Serial.print(sp);
#endif  

   
  // Рисуем азимут ветра
   myDisplay.PrintIcon7x7(0,9,0,0);
   if( dir>=0 && dir < 8 )myDisplay.PrintIcon7x7(0,9,dir+1,7); 
  
// Рисуем силу ветра
   off = 9;
   x2 = (sp)%10;
   x1 = (sp/10)%10;
   if( x1 > 0 ){
      myDisplay.PrintChar6h(off,10,x1,5);
      off+=4;
   }
   myDisplay.PrintChar6h(off,10,x2,5);
   off+=4;
   myDisplay.PrintIcon5x5(off,11,4,5);
   off+=4;
   myDisplay.PrintIcon5x5(off,11,5,5);
 // Парсим облачность и дождь
   uint8_t drop   = prec%10;
   uint16_t cloud = prec/10;
#ifdef DEBUG
          Serial.print(" CLOUD=");
          Serial.print(cloud);
          Serial.print(" DROP=");
          Serial.println(drop);
#endif  


   uint8_t y_off =0;
   if( cloud <= 20 ){
      myDisplay.PrintIcon9x9(23,0,0,7);
   }
   else if( cloud <= 40 ){
      myDisplay.PrintIcon9x9(23,0,0,7);
      myDisplay.PrintIcon9x9(22,5,2,1);
   } 
   else if( cloud <= 60 ){
      myDisplay.PrintIcon9x9(23,0,0,7);
      myDisplay.PrintIcon9x9(22,5,1,1);
   } 
   else if( cloud <= 80 ){
      myDisplay.PrintIcon9x9(23,0,2,1);
      myDisplay.PrintIcon9x9(20,3,2,1);
  } 
   else {
      myDisplay.PrintIcon9x9(23,0,1,1);
      myDisplay.PrintIcon9x9(20,3,1,1);
   }
   
//   рисуем осадки
   PrintRain(prec,true);
}

/**
* Показать дождь (нужно для миганияи дождем
*/ 
void PrintRain(unsigned long prec, boolean flag){
 // Парсим облачность и дождь
   byte color = 0;
   if( flag ) color = 3;
   uint8_t drop   = prec%10;
   uint16_t cloud = prec/10;
   uint8_t y_off =0;
   if( cloud <= 20 )y_off = 9;
   else if( cloud <= 40 )y_off = 11;
   else if( cloud <= 60 )y_off = 11;
   else if( cloud <= 80 )y_off = 9;
   else  y_off = 9;
    
//   рисуем осадки
   if( drop <= 0 )myDisplay.PrintIcon5x5(25,y_off,0,color);
   else if( drop < 4 )myDisplay.PrintIcon5x5(25,y_off,1,color);
   else if( drop < 6 )myDisplay.PrintIcon5x5(25,y_off,2,color);
   else myDisplay.PrintIcon5x5(25,y_off,3,color);
}

